/***************************************************
                 ACHTUNG auf defs.h achten !
*/
#include <stdio.h>
#include <string.h> 
#include "wg/config.h"
#include "wg/src/wget.h"
#include "wg/src/options.h"
#include "wg/src/retr.h"
#include "../h/defs.h"
$include sqlca;
$include sqlstype;
$include sqltypes;    
#define JDEBUG
 
struct options opt;

extern int find_suchbegriff(FILE *fp, char *suchbegriff);

main()
{
	$int lfnr;
	$long datum;
/*
	$char lfnr[LFNR_LEN];
*/
	$char url[URL_LEN];
	$char thema[THEMA_LEN];
	$char suchbegriff[SUCHBEGRIFF_LEN];
	$char buffer[315];	/* buffer fuer suchbegriff und thema */
	$int suchzahl;
	$int gueltig;
	$int mtime;
	$int isize;

	char datestr[20];
	int status, dt, i, treffer;
	char *filename, *new;
/* initialize options for wget  */
	opt.verbose = 1;
	opt.quiet = 1;
	opt.ntry = 2;
	opt.kill_longer = 0;
	opt.relative_only = 0;
	opt.no_parent = 1;
	opt.simple_check = 1;
	opt.maxreclevel = 1;
	opt.prefix_files = 0;
	opt.dirstruct = 0;
	opt.no_dirstruct = 0;
	opt.dirmode = 0;
	opt.add_hostdir = 0;
	opt.noclobber = 0;
	opt.dir_prefix = NULL;
	opt.fileprefix = NULL;
	opt.lfilename = NULL;
	opt.input_filename = NULL;
	opt.force_html = 0;
	opt.spider = 0;
	opt.accepts = NULL;
	opt.rejects = NULL;
	opt.excludes = NULL;
	opt.domains = NULL;
	opt.follow_ftp = 0;
	opt.output_document = (char *)malloc(sizeof(OUTNAME));
	strcpy(opt.output_document, OUTNAME);
	opt.always_rest = 0;
	opt.ftp_acc = NULL;
	opt.ftp_pass = NULL;
	opt.ftp_glob = 0;
	opt.http_user = NULL;
	opt.http_passwd = NULL;
	opt.user_header = NULL;
	opt.lfile = fopen(LOGNAME,"w");
	if (!opt.lfile)
	{
		perror("failed to open logfile:");
		exit(-1);
	}
	opt.use_proxy = 1;
	opt.proxy_cache = 1;
	opt.http_proxy = (char *)malloc(sizeof(PROXYNAME));
	strcpy(opt.http_proxy, PROXYNAME);
	opt.ftp_proxy = NULL;
	opt.no_proxy = NULL;
	opt.base_href = NULL;
	opt.timeout = 11;
	opt.use_robots = 0;
	opt.quota = 500*1024;
	opt.downloaded = 0;
	opt.numurls = 0;
	opt.print_server_response = 0;
	opt.save_headers = 0;
	opt.timestamping = 1;
	opt.backups = 0;
	opt.useragent = (char *)malloc(sizeof(AGENTNAME));
	strcpy(opt.useragent, AGENTNAME);
	opt.convert_links = 0;
	opt.remove_listing = 0;
	opt.jspecial = 1;
/*  ende der opt_initialisierung */

	dbpath();
	$database "/home/daten/dbanz";
		if (sqlca.sqlcode != 0)
		{
			printf("SQL-CODE: %d\n", sqlca.sqlcode);
			exit(0);
		}

	$declare zeigera cursor for
			select lfnr, datum, url, thema, suchbegriff, suchzahl, gueltig, mtime, isize
			 into $lfnr, $datum, $url, $thema, $suchbegriff, $suchzahl, $gueltig, $mtime, $isize
			from such  for update of suchzahl, gueltig, mtime, isize ;

	$open zeigera;
	
	for(;;)
	{
		$fetch zeigera;
	printf(".");
		if (sqlca.sqlcode != 0)
		{
			if (sqlca.sqlcode == SQLNOTFOUND)
				break;
			printf("SQL-CODE: %d\n", sqlca.sqlcode);
			exit(0);
		}
		for (i=0;i<60;i++)
		{
			if((url[i] == ' ') & (url[i+1] == ' '))
				url[i] = '\0';
		}
#ifdef JDEBUG 
		printf("gefundene url: \"%s\" \n",url);
		printf("lfnr: %d\n",lfnr);
		if (risnull(CDATETYPE,&datum))
			printf("datum: NULL\n");
		else
		{
			rdatestr(datum,datestr);
			printf("datum: %ld (%s)\n",datum, datestr);
		}
		printf("thema: %s\n", thema);
		printf("suchbegriff: %s\n", suchbegriff);
		printf("suchzahl %d\n", suchzahl);
		printf("gueltig %d\n", gueltig);
		printf("mtime %d\n", mtime);
		printf("size %d\n", isize);
#endif

		opt.dfp = fopen(OUTNAME,"wb");
		if (!opt.dfp)
		{
			perror("failed to open outputfile:");
			exit(-1);
		}
		/* mtime und size aus DB setzen */
		opt.mtime = mtime;
		opt.size = isize;
		/* url aus dem Netz lesen */
		status = retrieve_url(url, &filename, &new, NULL, &dt);

		if (status == RETROK) 
		{
			/* dokument gefunden */
			if ((mtime < opt.mtime) || (isize != opt.size))
			{
				/* dokument veraendert */
				fclose (opt.dfp);
				opt.dfp = fopen(OUTNAME,"rb");
				if (!opt.dfp)
				{
					perror("failed to reopen outputfile:");
					exit(-1);
				}
				/* dokument nach suchbegriff durchsuchen */
				strcpy(buffer,suchbegriff);
				strcat(buffer," "); 
				strcat(buffer,thema);
				treffer = find_suchbegriff(opt.dfp, buffer);
				if (treffer > 0 )
				{
				if (suchzahl < MAXSUCHZAHL)
				    suchzahl = suchzahl +1;
				}

#ifdef JDEBUG
				printf("treffer: %d updating\n",treffer);
#endif
				mtime = opt.mtime;
				isize = opt.size;
				if (gueltig < MAXGUELTIG)
				   gueltig = gueltig +1;
#ifdef JDEBUG
				printf("updating gueltig +1\n");
#endif
				$update such
					set suchzahl = $suchzahl, mtime = $mtime, isize = $isize, gueltig = $gueltig 
					where current of zeigera;
				if (sqlca.sqlcode != 0)
				{
					printf("SQL-CODE: %d\n", sqlca.sqlcode);
				}
			}
			else
			{
				/* dokument unveraendert */
				fclose (opt.dfp);
				mtime = opt.mtime;
				isize = opt.size;
				if (gueltig < MAXGUELTIG)
				   gueltig = gueltig +1;
#ifdef JDEBUG
				printf("updating gueltig +1\n");
#endif
				$update such
					set gueltig = $gueltig 
					where current of zeigera;
				if (sqlca.sqlcode != 0)
				{
					printf("SQL-CODE: %d\n", sqlca.sqlcode);
				}
			}
		}
		else if (status == WRONGCODE)
		{
#ifdef JDEBUG
				printf("WRONGCODE: \n");
#endif
			/* dokument nicht gefunden */
				fclose (opt.dfp);
#ifdef JDEBUG
				printf("updating gueltig -1\n");
#endif
				mtime = opt.mtime;
				isize = opt.size;
				if (suchzahl > 1)
				suchzahl = suchzahl -1;
				if (gueltig > 1)
				gueltig = gueltig -1;
				$update such
					set suchzahl = $suchzahl, gueltig = $gueltig 
					where current of zeigera;
				if (sqlca.sqlcode != 0)
				{
					printf("SQL-CODE: %d\n", sqlca.sqlcode);
				}
		}
		else
		{
#ifdef JDEBUG
			printf("status: %d\n",status);
#endif
		}
			
#ifdef JDEBUG
		printf("status: %d\n",status);
		printf("new mtime: %ld\n", opt.mtime);
		printf("new size: %d\n", opt.size);
		printf("-----------------------------------\n");
#endif
		fclose (opt.dfp);
	}
	$close zeigera;
}
